#macro SSS_BuildNormals()

  #if(sssfO=false) SSS_OrientFaces() #end

  #ifndef(sssaES) SSS_DefaultSharpData() #end
  
  #while(defined(sssaFN)) #undef sssaFN #end
  #while(defined(sssaN)) #undef sssaN #end
  #declare sssaFN=array[ssscF][4]
  #local iF=0;#while(iF<ssscF)
    #declare sssaFN[iF][0]=-1;
    #declare sssaFN[iF][1]=-1;
    #declare sssaFN[iF][2]=-1;
    #declare sssaFN[iF][3]=-1;
  #local iF=iF+1;#end  

#if(sssfProgressReports)
  #debug "Distributing normals.\n"
#end  

  #declare ssscN=0;
  #local iF=0;#while(iF<ssscF)
//    #debug concat("Face ",str(iF,0,0),"\n")
    #local cE=((sssaFV[iF][3]=-1)?3:4);
    #local iC=0;#while(iC<cE)
      #if(sssaFN[iF][iC]=-1) // this corner not done yet
        #declare sssaFN[iF][iC]=ssscN;
        #local iV=sssaFV[iF][iC]; // central vertex
        #local iEB=sssaFE[iF][iC];// forward-looking edge
        #local iFC=iF;
        #local iEC=iEB;
        #local fD=0;
        #local cF=1; // faces involved in building normal
        #while(sssaES[iEC]=0 & fD=0) // go one way
          #local iFO=sssaEF[iEC][0];
          #if(iFO=iFC) #local iFO=sssaEF[iEC][1]; #end
          #local iFC=iFO;
          #if(iV=sssaFV[iFC][0])
            #local iEC=sssaFE[iFC][0];
            #declare sssaFN[iFC][0]=ssscN;
          #end
          #if(iV=sssaFV[iFC][1])
            #local iEC=sssaFE[iFC][1];
            #declare sssaFN[iFC][1]=ssscN;
          #end
          #if(iV=sssaFV[iFC][2])
            #local iEC=sssaFE[iFC][2];
            #declare sssaFN[iFC][2]=ssscN;
          #end
          #if(iV=sssaFV[iFC][3])
            #local iEC=sssaFE[iFC][3];
            #declare sssaFN[iFC][3]=ssscN;
          #end
          #if(iEC=iEB) #local fD=1; #end
        #end
//
        #if(fD=0) // hit sharp edge before reaching start, go other way
          #local iEC=sssaFE[iF][mod(iC+cE-1,cE)];
          #local iFC=iF;
          #while(sssaES[iEC]=0) // go other way
            #local iFO=sssaEF[iEC][0];
            #if(iFO=iFC) #local iFO=sssaEF[iEC][1]; #end
            #local iFC=iFO;
            #local cF=cF+1;
            #local cO=((sssaFV[iFC][3]=-1)?3:4);
            #if(iV=sssaFV[iFC][0])
              #local iEC=sssaFE[iFC][cO-1];
              #declare sssaFN[iFC][0]=ssscN;
            #end
            #if(iV=sssaFV[iFC][1])
              #local iEC=sssaFE[iFC][0];
              #declare sssaFN[iFC][1]=ssscN;
            #end
            #if(iV=sssaFV[iFC][2])
              #local iEC=sssaFE[iFC][1];
              #declare sssaFN[iFC][2]=ssscN;
            #end
            #if(iV=sssaFV[iFC][3])
              #local iEC=sssaFE[iFC][2];
              #declare sssaFN[iFC][3]=ssscN;
            #end
          #end // end of while loop
        #end // end of fD=0 section
        #declare ssscN=ssscN+1;
      #end // end of sssaFN[iF][iC]=-1 check
    #local iC=iC+1;#end
  #local iF=iF+1;#end
#end

#macro SSS_CalculateNormals()
#if(sssfProgressReports)
  #debug "Calculating normals.\n"
#end  

  #while(defined(sssaN)) #undef sssaN #end
  #declare sssaN=array[ssscN]

  #local iN=0;#while(iN<ssscN)
    #declare sssaN[iN]=<0,0,0>;
  #local iN=iN +1;#end

  #local iF=0;#while(iF<ssscF)
    #local pA=sssaV[sssaFV[iF][0]];
    #local pB=sssaV[sssaFV[iF][1]];
    #local pC=sssaV[sssaFV[iF][2]];
    #local iNA=sssaFN[iF][0];
    #local iNB=sssaFN[iF][1];
    #local iNC=sssaFN[iF][2];
    #if(sssaFV[iF][3]=-1)
      #local vC=vcross(pB-pA,pC-pA);
      #declare sssaN[iNA]=sssaN[iNA]+vC;
      #declare sssaN[iNB]=sssaN[iNB]+vC;
      #declare sssaN[iNC]=sssaN[iNC]+vC;
    #else
      #local pD=sssaV[sssaFV[iF][3]];
      #local iND=sssaFN[iF][3];

      #declare sssaN[iNA]=sssaN[iNA]+vcross(pB-pA,pD-pA);
      #declare sssaN[iNB]=sssaN[iNB]+vcross(pC-pB,pA-pB);
      #declare sssaN[iNC]=sssaN[iNC]+vcross(pD-pC,pB-pC);
      #declare sssaN[iND]=sssaN[iND]+vcross(pA-pD,pC-pD);
    #end
  #local iF=iF+1;#end    
#end
