#include "data.h"
#include <math.h>
#include <gl/glu.h>

extern PPROJECT ActiveProject;
extern HWND hwndMain,hwndStatusBar,hwndToolBar;
extern RECT statRect;
extern MYPTR HighItem;
extern short HighType;
extern HFONT AxisFont;
extern matrix iom;

GLsizei ListStart;
HDC hdc=(HDC)0;

COLORREF	PenColor[PENCOUNT]={
	0x0000ff,	// XAXISPEN
	0x00ff00,	// YAXISPEN
	0xff0000,	// ZAXISPEN
	0xffbf7f,	// LABELPEN

	0x80c000,	// MARKPEN
	0x00ffff,	// HIGHPEN
	0xffff00,	// SHAFTPEN
	0xffffff,	// KNOBPEN

	0xffffff,	// VERTPEN
	0x666666,	// FINEPEN
	0x999999,	// GRIDPEN
	0xcccccc,	// EDGEPEN

	0x004080,	// ORPHANPEN
	0xbf7fff,	// BORDERPEN
	0x007fff,	// SHARPPEN
	0xf00080	// NEWPEN
};

HGLRC hrc=(HGLRC)0;

float Arrow[9][6]={
	{  1.00,0.00,0.00,-0.90,0.0,0.0 },
	{ -1.00,-.05,0.00,-0.90,0.0,0.0 },
	{ -1.00, .05,0.00,-0.90,0.0,0.0 },
	{ -1.00,0.00,-.05,-0.90,0.0,0.0 },
	{ -1.00,0.00, .05,-0.90,0.0,0.0 },
	{  0.90,-.05,0.00, 1.00,0.0,0.0 },
	{  0.90,0.05,0.00, 1.00,0.0,0.0 },
	{  0.90,0.00,-.05, 1.00,0.0,0.0 },
	{  0.90,0.00,0.05, 1.00,0.0,0.0 }
};

float ScaleTable[27]={
	.001000,.002000,.005000,
	.010000,.020000,.050000,
	.100000,.200000,.500000,
	1.00000,2.00000,5.00000,
	10.0000,20.0000,50.0000,
	100.000,200.000,500.000,
	1000.00,2000.00,5000.00,
	10000.0,20000.0,50000.0,
	100000.,200000.,500000. };

void DrawAxes(void) {
	short i,j;
	short c_u,c_r,c_f;
	vec p,s,e;
	float sC,pR,pU,pF,lim_r,lim_u,fR,fU;
	view *v;
	char numBuff[20];

	v=&(ActiveProject->cView);

	sC=v->Scale;

	if(v->Flags&VF_NONPARALLEL) {
		pR=v->Orient[LX];
		pU=v->Orient[LY];
		pF=v->Orient[LZ];

		glBegin(GL_LINES);
		SelectGLColor(PenColor[XAXISPEN]);
		for(i=0;i<9;i++) {
			glVertex3f((GLfloat)Arrow[i][0]*sC+pR,(GLfloat)Arrow[i][1]*sC+pU,(GLfloat)Arrow[i][2]*sC+pF);
			glVertex3f((GLfloat)Arrow[i][3]*sC+pR,(GLfloat)Arrow[i][4]*sC+pU,(GLfloat)Arrow[i][5]*sC+pF);
		}
		SelectGLColor(PenColor[YAXISPEN]);
		for(i=0;i<9;i++) {
			glVertex3f((GLfloat)Arrow[i][2]*sC+pR,(GLfloat)Arrow[i][0]*sC+pU,(GLfloat)Arrow[i][1]*sC+pF);
			glVertex3f((GLfloat)Arrow[i][5]*sC+pR,(GLfloat)Arrow[i][3]*sC+pU,(GLfloat)Arrow[i][4]*sC+pF);
		}
		SelectGLColor(PenColor[ZAXISPEN]);
		for(i=0;i<9;i++) {
			glVertex3f((GLfloat)Arrow[i][1]*sC+pR,(GLfloat)Arrow[i][2]*sC+pU,(GLfloat)Arrow[i][0]*sC+pF);
			glVertex3f((GLfloat)Arrow[i][4]*sC+pR,(GLfloat)Arrow[i][5]*sC+pU,(GLfloat)Arrow[i][3]*sC+pF);
		}
		glEnd();
	} else {
		if(fabs(v->Orient[ZX])==1.0) { c_r=Z; c_u=Y; c_f=X; }
		if(fabs(v->Orient[ZY])==1.0) { c_r=X; c_u=Z; c_f=Y; }
		if(fabs(v->Orient[ZZ])==1.0) { c_r=X; c_u=Y; c_f=Z; }

		for(i=1;i<27 && sC*.4>ScaleTable[i];i++);
		pR=ScaleTable[i];

		switch(i) {
			case  2: case  5: case  8:
			case 11: case 14: case 17:
			case 20: case 23: case 26:
			case 29: case 32: case 35:
				pU=ScaleTable[i-2];
				j=5;
			break;
			default:
				pU=ScaleTable[i-1];
				j=2;
			break;
		}

		if(v->sX>v->sY) {
			fR=sC*(float)v->sX/(float)v->sY;
			fU=sC;
		} else {
			fU=sC*(float)v->sY/(float)v->sX;
			fR=sC;
		}

		i=0;
		p[c_r]=pR*floor((v->Orient[LX+c_r]-fR)/pR);
		p[c_u]=pR*floor((v->Orient[LX+c_u]-fU)/pR);
		p[c_f]=v->Orient[LX+c_f];

		lim_r=v->Orient[LX+c_r]+fR;
		lim_u=v->Orient[LX+c_u]+fU;

		glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE_MINUS_SRC_COLOR);

		do {
			SelectGLColor(((i==0)?PenColor[GRIDPEN]:PenColor[FINEPEN]));

			s[c_r]=e[c_r]=p[c_r];
			s[c_u]=v->Orient[LX+c_u]-fU;
			e[c_u]=s[c_u]+fU*2.0;
			s[c_f]=e[c_f]=p[c_f];

			glEnable(GL_BLEND);
			glBegin(GL_LINES);
			glVertex3fv((const GLfloat*)&s);
			glVertex3fv((const GLfloat*)&e);
			glEnd();
			glDisable(GL_BLEND);

			if (i==0) {
                sprintf(numBuff,"%g",p[c_r]);

                glDisable(GL_DEPTH_TEST);

			    s[c_r]-=fR*8.0*(float)strlen(numBuff)/(float)(v->sX);
//			    s[c_u]+=fU*0.0/(float)(v->sY);

			    e[c_r]=s[c_r]+fR*16.0*(float)strlen(numBuff)/(float)(v->sX);
			    e[c_u]=s[c_u]+fU*24.0/(float)(v->sY);

				SelectGLColor((COLORREF)0);

			    glRectfv((const GLfloat*)&s,(const GLfloat*)&e);

			    s[c_r]+=fR*2.0/(float)(v->sX);
			    s[c_u]+=fU*4.0/(float)(v->sY);

			    SelectGLColor(PenColor[LABELPEN]);
			    glRasterPos3fv((const GLfloat*)&s);
			    glCallLists(strlen(numBuff),GL_UNSIGNED_BYTE,numBuff);
                glEnable(GL_DEPTH_TEST);
			}

			SelectGLColor(((i==0)?PenColor[GRIDPEN]:PenColor[FINEPEN]));
			s[c_r]=v->Orient[LX+c_r]-fR;
			e[c_r]=s[c_r]+fR*2.0;
			s[c_u]=e[c_u]=p[c_u];
//			s[c_f] & e[c_f] reused from prior values
			glEnable(GL_BLEND);
    		glBegin(GL_LINES);
			glVertex3fv((const GLfloat*)&s);
			glVertex3fv((const GLfloat*)&e);
			glEnd();
			glDisable(GL_BLEND);

			if (i==0) {
                glDisable(GL_DEPTH_TEST);
			    sprintf(numBuff,"%g",p[c_u]);
// s has <0,y>
			    s[c_r]+=fR*4.0/(float)(v->sX);
			    s[c_u]-=fU*12.0/(float)(v->sY);
			    e[c_r]=s[c_r]+fR*(16.0*(float)strlen(numBuff)+2.0)/(float)(v->sX);
			    e[c_u]=s[c_u]+fU*24.0/(float)(v->sY);

			    SelectGLColor((COLORREF)0);

			    glRectfv((const GLfloat*)&s,(const GLfloat*)&e);

			    s[c_r]+=fR*2.0/(float)(v->sX);
			    s[c_u]+=fU*4.0/(float)(v->sY);

				SelectGLColor(PenColor[LABELPEN]);
			    glRasterPos3fv((const GLfloat*)&s);
			    glCallLists(strlen(numBuff),GL_UNSIGNED_BYTE,numBuff);
                glEnable(GL_DEPTH_TEST);
			}

			if(++i==j) i=0;
			p[c_r]=floor(p[c_r]/pU+1.5)*pU;
			p[c_u]=floor(p[c_u]/pU+1.5)*pU;
		} while(p[c_r]<lim_r || p[c_u]<lim_u);
	}
}

void DrawEdges(void) {
	MYPTR m;

	STEPEDGES(ActiveProject,m.e)
	DrawLSMEdge(m.e);
}

void DrawFaces(void) {
	face* f;
	tint* t;

	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glEnable(GL_POLYGON_OFFSET_FILL);
	glPolygonOffset(1.0,1.0);

// draw triangles
	STEPFACES(ActiveProject,f)
	if(f->VertD==NULL) {
		t=f->Texture;
		if(t==NULL) t=((PMODEL)ActiveProject)->defTint;
	    if(f->MapA==NULL) {
    		SelectGLColor(t->color);
			glBegin(GL_TRIANGLES);
    		glVertex3fv((GLfloat *)&f->VertA->Spot);
    		glVertex3fv((GLfloat *)&f->VertB->Spot);
    		glVertex3fv((GLfloat *)&f->VertC->Spot);
			glEnd();
   		} else {
   			if(t->bmBits==NULL) GetTintBitmap(t);
    		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,t->sX,t->sY,0,GL_BGR_EXT,GL_UNSIGNED_BYTE,t->bmBits);
			glEnable(GL_TEXTURE_2D);
			DrawMappedPolygon(f->MapA->Spot,f->VertA->Spot,
				f->MapB->Spot,f->VertB->Spot,f->MapC->Spot,f->VertC->Spot,
				NULL,NULL);
			glDisable(GL_TEXTURE_2D);
   		}
	}

// and quads
	STEPFACES(ActiveProject,f)
	if(f->VertD!=NULL) {
		t=f->Texture;
		if(t==NULL) t=((PMODEL)ActiveProject)->defTint;
	    if(f->MapA==NULL) {
    		SelectGLColor(t->color);
			glBegin(GL_QUADS);
    		glVertex3fv((GLfloat *)&f->VertA->Spot);
    		glVertex3fv((GLfloat *)&f->VertB->Spot);
    		glVertex3fv((GLfloat *)&f->VertC->Spot);
    		glVertex3fv((GLfloat *)&f->VertD->Spot);
			glEnd();
   		} else {
   			if(t->bmBits==NULL) GetTintBitmap(t);
    		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,t->sX,t->sY,0,GL_BGR_EXT,GL_UNSIGNED_BYTE,t->bmBits);
			glEnable(GL_TEXTURE_2D);
			DrawMappedPolygon(f->MapA->Spot,f->VertA->Spot,
				f->MapB->Spot,f->VertB->Spot,f->MapC->Spot,f->VertC->Spot,
				f->MapD->Spot,f->VertD->Spot);
			glDisable(GL_TEXTURE_2D);
   		}
	}
}

void DrawHighlight(void) {
//	vert *v;

	GLubyte mark[7]= { 0xfe,0x82,0x82,0x82,0x82,0x82,0xfe };
	GLubyte knob[18]= { 0x08,0x00, 0x14,0x00, 0x22,0x00, 0x41,0x00,
		0x80,0x80, 0x41,0x00, 0x22,0x00, 0x14,0x00, 0x08,0x00,};

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE_MINUS_SRC_COLOR);
	SelectGLColor(PenColor[HIGHPEN]);
	switch(HighType) {
		case HT_NOTHING:
		break;
		case HT_UVPT:
			glRasterPos2fv((GLfloat *)&HighItem.u->Spot);
			glBitmap((GLsizei)7,(GLsizei)7,(GLfloat)3.0,(GLfloat)3.0,(GLfloat)0.0,(GLfloat)0.0,mark);
		break;
		case HT_VERT:
			glRasterPos3fv((GLfloat *)&HighItem.v->Spot);
			glBitmap((GLsizei)7,(GLsizei)7,(GLfloat)3.0,(GLfloat)3.0,(GLfloat)0.0,(GLfloat)0.0,mark);
		break;
		case HT_KNOB:
			glRasterPos3fv((GLfloat *)&HighItem.k->Spot);
			glBitmap((GLsizei)9,(GLsizei)9,(GLfloat)4.0,(GLfloat)4.0,(GLfloat)0.0,(GLfloat)0.0,knob);
		break;
		case HT_PART:
			glLineWidth(3.0);
			glBegin(GL_LINES);
			glVertex3fv((GLfloat *)&HighItem.p->Base->Spot);
			glVertex3fv((GLfloat *)&HighItem.p->End->Spot);
			glVertex3fv((GLfloat *)&HighItem.p->Rise->Spot);
			glVertex3f((GLfloat)HighItem.p->Base->Spot[X]*.25+HighItem.p->End->Spot[X]*.75,
				(GLfloat)HighItem.p->Base->Spot[Y]*.25+HighItem.p->End->Spot[Y]*.75,
				(GLfloat)HighItem.p->Base->Spot[Z]*.25+HighItem.p->End->Spot[Z]*.75);
			glEnd();
			glLineWidth(1.0);
		break;
		case HT_EDGE:
			glLineWidth(3.0);
			glBegin(GL_LINES);
			glVertex3fv((GLfloat *)&HighItem.e->VertS->Spot);
			glVertex3fv((GLfloat *)&HighItem.e->VertE->Spot);
			glEnd();
			glLineWidth(1.0);
		break;
		case HT_FACE:
			glLineWidth(3.0);
			glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
			glBegin(GL_POLYGON);
			glVertex3fv((GLfloat *)&HighItem.f->VertA->Spot);
			glVertex3fv((GLfloat *)&HighItem.f->VertB->Spot);
			glVertex3fv((GLfloat *)&HighItem.f->VertC->Spot);
			if(HighItem.f->VertD)
			glVertex3fv((GLfloat *)&HighItem.f->VertD->Spot);
			glEnd();
			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
			glLineWidth(1.0);

		break;
	}
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
}

void DrawKnobs(void) {
	knob* k;
	GLubyte lbox[5]= { 0x20,0x50,0x88,0x50,0x20 };

	glPixelStorei(GL_UNPACK_ALIGNMENT,1);

	SelectGLColor(PenColor[KNOBPEN]);
	STEPKNOBS(ActiveProject,k) {
		glRasterPos3fv((GLfloat *)&k->Spot);
		glBitmap((GLsizei)5,(GLsizei)5,(GLfloat)2.0,(GLfloat)2.0,(GLfloat)0.0,(GLfloat)0.0,lbox);
	}
}

void DrawLSMEdge(edge* e) {
	int ci;

	switch(e->Flags&EF_PENMASK) {
	case 0:
		ci=EDGEPEN;
	break;
	case TF_SHARP:
		ci=SHARPPEN;
	break;
	case EF_NOLEFT:
	case EF_NORIGHT:
	case EF_NOLEFT|TF_SHARP:
	case EF_NORIGHT|TF_SHARP:
		ci=BORDERPEN;
	break;
	case EF_NOLEFT|EF_NORIGHT:
	case EF_NOLEFT|EF_NORIGHT|TF_SHARP:
		ci=ORPHANPEN;
	break;
	}

	glBegin(GL_LINES);
	SelectGLColor(PenColor[ci]);
	glVertex3fv((GLfloat *)&e->VertS->Spot);
	glVertex3fv((GLfloat *)&e->VertE->Spot);
	glEnd();
}

void DrawMappedPolygon(float* ta,float* pa,float* tb,float* pb,float* tc,float* pc,
	float* td,float* pd) {
	GLfloat minx,miny;

	minx=ta[U];
	if(minx>tb[U]) minx=tb[U];
	if(minx>tc[U]) minx=tc[U];

	miny=ta[V];
	if(miny>tb[V]) miny=tb[V];
	if(miny>tc[V]) miny=tc[V];

	if(td!=NULL) {
		if(minx>td[U]) minx=td[U];
		if(miny>td[V]) miny=td[V];
		glBegin(GL_QUADS);
	} else {
		glBegin(GL_TRIANGLES);
	}

	minx=floor(minx);
	miny=floor(miny);

	glTexCoord2f(ta[U]-minx,ta[V]-miny);
	glVertex3fv((GLfloat*)pa);
	glTexCoord2f(tb[U]-minx,tb[V]-miny);
	glVertex3fv((GLfloat*)pb);
	glTexCoord2f(tc[U]-minx,tc[V]-miny);
	glVertex3fv((GLfloat*)pc);
	if(td!=NULL) {
		glTexCoord2f(td[U]-minx,td[V]-miny);
		glVertex3fv((GLfloat*)pd);
	}

	glEnd();
}

void DrawMarking(void) {
	edge *e;

	glLineWidth(3.0);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE_MINUS_SRC_COLOR);
	glBegin(GL_LINES);

	STEPEDGES(ActiveProject,e) {
		if(e->VertS->Flags&e->VertE->Flags&TF_MARKED) {
			SelectGLColor(PenColor[MARKPEN]);
			glVertex3fv((GLfloat *)&e->VertS->Spot);
			glVertex3fv((GLfloat *)&e->VertE->Spot);
		}
		else if(e->VertS->Select>1
			&& (e->VertE->Select==e->VertS->Select-1 || e->VertE->Select==e->VertS->Select+1)) {
			SelectGLColor(PenColor[NEWPEN]);
			glVertex3fv((GLfloat *)&e->VertS->Spot);
			glVertex3fv((GLfloat *)&e->VertE->Spot);
		}
	}
	glEnd();

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glLineWidth(1.0);
}

void DrawParts(void) {
	part* p;

	SelectGLColor(PenColor[SHAFTPEN]);
	glBegin(GL_LINES);
	STEPPARTS(ActiveProject,p) {
		glVertex3fv((GLfloat *)&p->Base->Spot);
		glVertex3fv((GLfloat *)&p->End->Spot);
		glVertex3f((GLfloat)p->Base->Spot[X]*.25+p->End->Spot[X]*.75,
			p->Base->Spot[Y]*.25+p->End->Spot[Y]*.75,
			p->Base->Spot[Z]*.25+p->End->Spot[Z]*.75);
		glVertex3fv((GLfloat *)&p->Rise->Spot);
	}
	glEnd();
}

void DrawUVEdges(void) {
	edge* e;
	face* f;
	int i;
	COLORREF cr;

	if(ActiveProject==NULL) return;

	STEPEDGES(ActiveProject,e)
	e->Flags|=TF_NEW;

	cr=((PMODEL)ActiveProject)->CurTint->color;

	glDisable(GL_DEPTH_TEST);

	for(i=0;i<2;i++) {

	if(i) {
  // thin lines and matching color
		glColor3d(floor(GetRValue(cr)/255.0+.5),floor(GetGValue(cr)/255.0+.5),
  			floor(GetBValue(cr)/255.0+.5));
     	glLineWidth(1.0);
	} else {
  // fat lines and opposite color
		glColor3d(floor(1.5-GetRValue(cr)/255.0),floor(1.5-GetGValue(cr)/255.0),
  			floor(1.5-GetBValue(cr)/255.0));
     	glLineWidth(3.0);
	}

	glBegin(GL_LINES);
	STEPFACES(ActiveProject,f)
	if(f->MapA)
	if(f->Texture==((PMODEL)ActiveProject)->CurTint) {
		glVertex2fv((const GLfloat*)&f->MapA->Spot);
		glVertex2fv((const GLfloat*)&f->MapB->Spot);
		glVertex2fv((const GLfloat*)&f->MapB->Spot);
		glVertex2fv((const GLfloat*)&f->MapC->Spot);
		glVertex2fv((const GLfloat*)&f->MapC->Spot);
		if(f->VertD) {
			glVertex2fv((const GLfloat*)&f->MapD->Spot);
			glVertex2fv((const GLfloat*)&f->MapD->Spot);
		}
		glVertex2fv((const GLfloat*)&f->MapA->Spot);
	}
	glEnd();

	}

   	glLineWidth(1.0);
	glEnable(GL_DEPTH_TEST);
}

void DrawUVPts(void) {
	face* f;
	GLubyte mark[5]= { 0xf8,0x88,0x88,0x88,0xf8 };
	GLubyte lbox[3]= { 0xef,0xaf,0xef };

	if(ActiveProject==NULL) return;

	STEPFACES(ActiveProject,f)
	if(f->MapA)
	if(f->Texture==((PMODEL)ActiveProject)->CurTint) {
		SelectGLColor(0xffffff);
		glRasterPos2fv((GLfloat *)&f->MapA->Spot);
		glBitmap((GLsizei)3,(GLsizei)3,(GLfloat)1.0,(GLfloat)1.0,(GLfloat)0.0,(GLfloat)0.0,lbox);
		SelectGLColor(0x000000);
		glRasterPos2fv((GLfloat *)&f->MapA->Spot);
		glBitmap((GLsizei)5,(GLsizei)5,(GLfloat)2.0,(GLfloat)2.0,(GLfloat)0.0,(GLfloat)0.0,mark);

		glRasterPos2fv((GLfloat *)&f->MapB->Spot);
		glBitmap((GLsizei)5,(GLsizei)5,(GLfloat)2.0,(GLfloat)2.0,(GLfloat)0.0,(GLfloat)0.0,mark);
		SelectGLColor(0xffffff);
		glRasterPos2fv((GLfloat *)&f->MapB->Spot);
		glBitmap((GLsizei)3,(GLsizei)3,(GLfloat)1.0,(GLfloat)1.0,(GLfloat)0.0,(GLfloat)0.0,lbox);

		glRasterPos2fv((GLfloat *)&f->MapC->Spot);
		glBitmap((GLsizei)3,(GLsizei)3,(GLfloat)1.0,(GLfloat)1.0,(GLfloat)0.0,(GLfloat)0.0,lbox);
		SelectGLColor(0x000000);
		glRasterPos2fv((GLfloat *)&f->MapC->Spot);
		glBitmap((GLsizei)5,(GLsizei)5,(GLfloat)2.0,(GLfloat)2.0,(GLfloat)0.0,(GLfloat)0.0,mark);

		if(f->VertD) {
			glRasterPos2fv((GLfloat *)&f->MapD->Spot);
			glBitmap((GLsizei)5,(GLsizei)5,(GLfloat)2.0,(GLfloat)2.0,(GLfloat)0.0,(GLfloat)0.0,mark);
			SelectGLColor(0xffffff);
			glRasterPos2fv((GLfloat *)&f->MapD->Spot);
			glBitmap((GLsizei)3,(GLsizei)3,(GLfloat)1.0,(GLfloat)1.0,(GLfloat)0.0,(GLfloat)0.0,lbox);
		}
	}
}

void DrawVertices(void) {
	vert* v;
//	BOOL flag;

	GLubyte lbox[3]= { 0xef,0xaf,0xef };
	GLubyte mark[7]= { 0xfe,0x82,0x82,0x82,0x82,0x82,0xfe };

//	UpdateStatusBar("Drawing vertices.",0,0);

	SelectGLColor(PenColor[VERTPEN]);
	STEPVERTS(ActiveProject,v) {
		glRasterPos3fv((GLfloat *)&v->Spot);
		glBitmap((GLsizei)3,(GLsizei)3,(GLfloat)1.0,(GLfloat)1.0,(GLfloat)0.0,(GLfloat)0.0,lbox);
	}

	SelectGLColor(PenColor[MARKPEN]);
	STEPVERTS(ActiveProject,v)
	if(v->Flags&TF_MARKED) {
		glRasterPos3fv((GLfloat *)&v->Spot);
		glBitmap((GLsizei)7,(GLsizei)7,(GLfloat)3.0,(GLfloat)3.0,(GLfloat)0.0,(GLfloat)0.0,mark);
	}
}

void RedoDisplay(void) {
	RECT sbrect;
	int cX,cY,offS,offT;
	PAINTSTRUCT ps;
//	GLfloat m[16];

	BeginPaint(hwndMain,&ps);
	EndPaint(hwndMain,&ps);

	if(!hdc) hdc=GetDC(hwndMain);

	if(hrc==(HANDLE)0) {
		InvalidateView();
		hrc=PrepareRenderingContext(hdc);
		wglMakeCurrent(hdc,hrc);
		ListStart=glGenLists(0x60);
		SelectObject(hdc,AxisFont);
		wglUseFontBitmaps(hdc,0x20,0x60,ListStart);
		glListBase((GLuint)ListStart-0x20);
	}

	if(ActiveProject) {
		GetClientRect(hwndMain,&ActiveProject->cView.Screen);
		GetClientRect(hwndStatusBar,&sbrect);
		offS=sbrect.bottom-sbrect.top;
		ActiveProject->cView.Screen.bottom-=offS;
		GetClientRect(hwndToolBar,&sbrect);
		offT=sbrect.bottom-sbrect.top;
		ActiveProject->cView.Screen.top+=offT;

		cX=ActiveProject->cView.Screen.right-ActiveProject->cView.Screen.left;
		cY=ActiveProject->cView.Screen.bottom-ActiveProject->cView.Screen.top;

		ActiveProject->cView.sX = cX;
		ActiveProject->cView.sY = cY;
		ActiveProject->cView.sM = (cX < cY) ? cX : cY;
		if(ActiveProject->cView.sM<2) ActiveProject->cView.sM=2;

		if(ActiveProject->Flags&MF_MESHCHANGED)
		ValidateMesh((PMODEL)ActiveProject);

// set up the view
		glMatrixMode(GL_PROJECTION);
		glViewport(0,offS,(GLsizei)cX,(GLsizei)cY);
		glLoadIdentity();
		loadIntoOpenGL(&ActiveProject->cView,cX,cY);
// get ready to render objects
		glShadeModel(GL_FLAT);
		glPixelStorei(GL_UNPACK_ALIGNMENT,1);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
		glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);


		switch(ActiveProject->EditMode) {
			case EM_MESHEDIT:

// turn on hidden object removal
				glEnable(GL_DEPTH_TEST);
				glDisable(GL_CULL_FACE);
// clear the screen
				glClearColor(0.0f,0.0f,0.0f,0.0f);	// clear to black
				glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

// and render them
				if(ActiveProject->Flags&MF_SHOWEDGES) DrawEdges();
				if(ActiveProject->Flags&MF_SHOWFACES) DrawFaces();
				if(ActiveProject->Flags&MF_SHOWVERTS) DrawVertices();
				if(ActiveProject->Flags&MF_SHOWPARTS)  {
					DrawParts();
					DrawKnobs();
				}
				if(ActiveProject->Flags&PF_SHOWAXES) DrawAxes();
				if(ActiveProject->Flags&MF_SHOWEDGES) DrawMarking();

			break;
			case EM_MAPEDIT:
				glDisable(GL_DEPTH_TEST);
				glDisable(GL_CULL_FACE);
// clear the screen
				glClear(GL_DEPTH_BUFFER_BIT);
				PaintMapBackground();
				if(ActiveProject->Flags&PF_SHOWAXES) DrawAxes();
                glDisable(GL_DEPTH_TEST);
				DrawUVEdges();
				DrawUVPts();
			break;
		}
		DrawHighlight();
	} else {
		glClearColor(0.0f,0.0f,0.0f,0.0f);	// clear to black
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	}

	glFlush();

	SwapBuffers(hdc);

	ReleaseDC(hwndMain,hdc);
	hdc=NULL;

	SetScroll();
}

void ResizeDisplay(void) { }

void PaintMapBackground(void) {
	vec va,vb,vc,vd;
	uvec ta,tb,tc,td;

	float vX,vY,/*vZ,*/ wX,wY;
	view *v;
	tint* t;

	v=&(ActiveProject->cView);

	t=((PMODEL)ActiveProject)->CurTint;

	vX=v->Orient[LX];
	vY=v->Orient[LY];
//	vZ=0.0;

	if(v->sX > v->sY) {
		wY=v->Scale;
		wX=wY*(float)v->sX/(float)v->sY;
	} else {
		wX=v->Scale;
		wY=wX*(float)v->sY/(float)v->sX;
	}

	if(t->bmBits==NULL) GetTintBitmap(t);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,t->sX,t->sY,0,GL_BGR_EXT,
		GL_UNSIGNED_BYTE,t->bmBits);
	ta[U]=tb[U]=va[X]=vb[X]=vX-wX;
	tc[U]=td[U]=vc[X]=vd[X]=vX+wX;
	ta[V]=td[V]=va[Y]=vd[Y]=vY-wY;
	tb[V]=tc[V]=vb[Y]=vc[Y]=vY+wY;
	va[Z]=vb[Z]=vc[Z]=vd[Z]=0.0;

	glEnable(GL_TEXTURE_2D);
	DrawMappedPolygon(ta,va,tb,vb,tc,vc,td,vd);
	glDisable(GL_TEXTURE_2D);

}

void SwapHandedness(void) {
/*
	float s;
	if(ActiveProject) {
		s=ActiveProject->cView.Orient[XY];
		ActiveProject->cView.Orient[XY]=ActiveProject->cView.Orient[XZ];
		ActiveProject->cView.Orient[XZ]=s;

		s=ActiveProject->cView.Orient[XY];
		ActiveProject->cView.Orient[XY]=ActiveProject->cView.Orient[XZ];
		ActiveProject->cView.Orient[XZ]=s;

		s=ActiveProject->cView.Orient[XY];
		ActiveProject->cView.Orient[XY]=ActiveProject->cView.Orient[XZ];
		ActiveProject->cView.Orient[XZ]=s;

		ActiveProject->cView.Flags^=VF_HANDMASK;
		InvalidateView();
	}
*/
}

void Jump2Origin(void) {
	if(ActiveProject) {
		ActiveProject->cView.Orient[LX]=
		ActiveProject->cView.Orient[LY]=
		ActiveProject->cView.Orient[LZ]=0.0;
		InvalidateView();
	}
}

void ValidateMesh(PMODEL m) {
	face* f;
	edge* e;
	int i;

	if(m==NULL) m=(PMODEL)ActiveProject;

	i=0;
	STEPEDGES(m,e) {
		e->FaceL=e->FaceR=NULL;
		i++;
	}

	i=0;
	STEPFACES(m,f) {
		e=FindEdge(m,f->VertA,f->VertB);
		f->EdgeE=e;
		if(e->FaceL==NULL)
		{ e->FaceL=f; } else { e->FaceR=f; }

		e=FindEdge(m,f->VertB,f->VertC);
		f->EdgeF=e;
		if(e->FaceL==NULL)
		{ e->FaceL=f; } else { e->FaceR=f; }

		if(f->VertD==NULL) {
			e=FindEdge(m,f->VertA,f->VertC);
			f->EdgeG=e;
			if(e->FaceL==NULL)
			{ e->FaceL=f; } else { e->FaceR=f; }

			f->EdgeH=NULL;
		} else {
			e=FindEdge(m,f->VertC,f->VertD);
			f->EdgeG=e;
			if(e->FaceL==NULL)
			{ e->FaceL=f; } else { e->FaceR=f; }

			e=FindEdge(m,f->VertA,f->VertD);
			f->EdgeH=e;
			if(e->FaceL==NULL)
			{ e->FaceL=f; } else { e->FaceR=f; }
		}
		i++;
	}

	STEPEDGES(m,e) {
		e->Flags&=~(EF_NOLEFT|EF_NORIGHT);
		if(e->FaceL==NULL) e->Flags|=EF_NOLEFT;
		if(e->FaceR==NULL) e->Flags|=EF_NORIGHT;
	}
	((PPROJECT)m)->Flags&=~MF_MESHCHANGED;
}

void InvalidateView(void) {
	InvalidateRect(hwndMain,NULL,FALSE);
}

void RightRect(RECT *r) {
	LONG swap;

	if(r->left > r->right) {
		swap=r->left;
		r->left=r->right;
		r->right=swap;
	}
	if(r->top > r->bottom) {
		swap=r->top;
		r->top=r->bottom;
		r->bottom=swap;
	}
}

void SelectGLColor(COLORREF cr) {
	glColor3f(GetRValue(cr)/255.0,GetGValue(cr)/255.0,GetBValue(cr)/255.0);
}

void ViewXY(void) {
	if(ActiveProject) {
		ActiveProject->cView.Orient[XX]=
		ActiveProject->cView.Orient[YY]=1.0;
		ActiveProject->cView.Orient[ZZ]=
			((ActiveProject->cView.Flags&VF_HANDMASK)==VF_LEFTHANDED)
			?1.0:-1.0;
		ActiveProject->cView.Orient[XY]=
		ActiveProject->cView.Orient[XZ]=
		ActiveProject->cView.Orient[YX]=
		ActiveProject->cView.Orient[YZ]=
		ActiveProject->cView.Orient[ZX]=
		ActiveProject->cView.Orient[ZY]=0.0;

		ActiveProject->cView.Flags&=~VF_NONPARALLEL;
		InvalidateView();
	}
}

void ViewXZ(void) {
	if(ActiveProject==NULL) return;
	if(ActiveProject->EditMode==EM_MAPEDIT) return;
	ActiveProject->cView.Orient[XX]=
	ActiveProject->cView.Orient[YZ]=1.0;
	ActiveProject->cView.Orient[ZY]=
		((ActiveProject->cView.Flags&VF_HANDMASK)==VF_LEFTHANDED)
		?-1.0:1.0;
	ActiveProject->cView.Orient[XY]=
	ActiveProject->cView.Orient[XZ]=
	ActiveProject->cView.Orient[YX]=
	ActiveProject->cView.Orient[YY]=
	ActiveProject->cView.Orient[ZX]=
	ActiveProject->cView.Orient[ZZ]=0.0;

	ActiveProject->cView.Flags&=~VF_NONPARALLEL;
	InvalidateView();
}

void ViewYZ(void) {
	if(ActiveProject==NULL) return;
	if(ActiveProject->EditMode==EM_MAPEDIT) return;
	ActiveProject->cView.Orient[ZX]=-1.0;
	if((ActiveProject->cView.Flags&VF_HANDMASK)==VF_LEFTHANDED) {
		ActiveProject->cView.Orient[XY]=
		ActiveProject->cView.Orient[YZ]=0.0;
		ActiveProject->cView.Orient[XZ]=
		ActiveProject->cView.Orient[YY]=1.0;
	} else {
		ActiveProject->cView.Orient[XY]=
		ActiveProject->cView.Orient[YZ]=1.0;
		ActiveProject->cView.Orient[XZ]=
		ActiveProject->cView.Orient[YY]=0.0;
	}
	ActiveProject->cView.Orient[XX]=
	ActiveProject->cView.Orient[YX]=
	ActiveProject->cView.Orient[ZY]=
	ActiveProject->cView.Orient[ZZ]=0.0;

	ActiveProject->cView.Flags&=~VF_NONPARALLEL;
	InvalidateView();
}

void Zoom2Fit(PPROJECT p) {
	MYPTR m;
	float minx,miny,maxx,maxy,minz,maxz,qf;
	vec redux,center;

	if(p==NULL) return;

	if(p->cView.sX<2 || p->cView.sY<2) return;

	maxx=maxy=maxz=-1.0e16;
	minx=miny=minz=1.0e16;

	switch(p->ProjectType) {
		case PT_MODEL:
		STEPVERTS(p,m.v) {
			InvertVector(p->cView.Orient,m.v->Spot,redux);
			if(redux[X]>maxx) maxx=redux[X];
			if(redux[X]<minx) minx=redux[X];
			if(redux[Y]>maxy) maxy=redux[Y];
			if(redux[Y]<miny) miny=redux[Y];
			if(redux[Z]>maxz) maxz=redux[Z];
			if(redux[Z]<minz) minz=redux[Z];
		}
		STEPKNOBS(p,m.k) {
			InvertVector(p->cView.Orient,m.k->Spot,redux);
			if(redux[X]>maxx) maxx=redux[X];
			if(redux[X]<minx) minx=redux[X];
			if(redux[Y]>maxy) maxy=redux[Y];
			if(redux[Y]<miny) miny=redux[Y];
			if(redux[Z]>maxz) maxz=redux[Z];
			if(redux[Z]<minz) minz=redux[Z];
		}
	}
	if((maxx-minx)<.00001 && (maxy-miny)<.00001) {
		qf=(maxx+minx)*.5;
 		minx=qf-.000005;
 		maxx=qf+.000005;
		qf=(maxy+miny)*.5;
		miny=qf-.000005;
 		maxy=qf+.000005;
	}

	qf=(float)p->cView.sX/(float)p->cView.sY;

	if(qf>1.0) {
		if((maxx-minx)>(maxy-miny)*qf) {
			p->cView.Scale=(maxx-minx)*.525/qf;
		} else {
			p->cView.Scale=(maxy-miny)*.525;
		}
	} else {
		if((maxx-minx)>(maxy-miny)*qf) {
			p->cView.Scale=(maxx-minx)*.525;
		} else {
			p->cView.Scale=(maxy-miny)*.525*qf;
		}
	}

	center[X]=(maxx+minx)*.5;
	center[Y]=(maxy+miny)*.5;
	center[Z]=(maxz+minz)*.5;
	TransformVector(p->cView.Orient,center,redux);
	p->cView.Orient[LX]=redux[X];
	p->cView.Orient[LY]=redux[Y];
	p->cView.Orient[LZ]=redux[Z];
	InvalidateView();
}

void ZoomInTenPercent(void) {
	if(ActiveProject) {
		ActiveProject->cView.Scale*=.909091;
		if(ActiveProject->cView.Scale<.00001) ActiveProject->cView.Scale=.00001;
		InvalidateView();
	}
}

void ZoomOutTenPercent(void) {
	if(ActiveProject) {
		ActiveProject->cView.Scale*=1.1;
		if(ActiveProject->cView.Scale>100000) ActiveProject->cView.Scale=100000;
		InvalidateView();
	}
}

