#include "data.h"
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <shellapi.h>
#include "lsmres.h"
#include <gl/glu.h>

HINSTANCE hInst;		// Instance handle
HWND hwndMain;		//Main window handle

extern MYPTR HighItem;
extern HGLRC hrc;
extern GLsizei  ListStart;

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);
/* --- The following code comes from c:\lcc\lib\wizard\statbar.tpl. */

// Global Variables for the status bar control.

HWND  hwndStatusBar;
HWND  hwndToolBar=(HWND)0;

HMENU ModelMenu,LameMenu,PopupMenu,DelPopupMenu,PartPopupMenu,KnobPopupMenu,EdgePopupMenu,
	VertPopupMenu,MapPopupMenu,UVPtPopupMenu,ExtrudePopupMenu,CopyPopupMenu;

HFONT	AxisFont;

chain Projects;

extern PPROJECT ActiveProject;
extern short MouseMode,lX,lY,EditMode;
extern BOOL Popup;
extern char *WindowTitle;
extern short HighType;

void CreateAppData(void) {
	AxisFont=CreateFont(8,8,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,
		DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,FF_MODERN|FIXED_PITCH,(LPCTSTR)"Courier");
	initChain(&Projects);
	ModelMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDMODELMENU));
	LameMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDLAMEMENU));
	PopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPMENU));
	DelPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPDEL));
	PartPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPPART));
	KnobPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPKNOB));
	EdgePopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPEDGE));
	VertPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPVERT));
	MapPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPMAP));
	UVPtPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPUVPT));
	ExtrudePopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPEXT));
	CopyPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPCOPY));
}

void DeleteAppData(void) {
	DeleteObject(AxisFont);
	DestroyMenu(ModelMenu);
	DestroyMenu(LameMenu);
	DestroyMenu(PopupMenu);
	DestroyMenu(DelPopupMenu);
	DestroyMenu(PartPopupMenu);
	DestroyMenu(KnobPopupMenu);
	DestroyMenu(EdgePopupMenu);
	DestroyMenu(VertPopupMenu);
	DestroyMenu(MapPopupMenu);
	DestroyMenu(UVPtPopupMenu);
	DestroyMenu(ExtrudePopupMenu);
	DestroyMenu(CopyPopupMenu);
}

void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags)
{
    SendMessage(hwndStatusBar,
                SB_SETTEXT,
                partNumber | displayFlags,
                (LPARAM)lpszStatusString);
}


/*------------------------------------------------------------------------
 Procedure:     MsgMenuSelect ID:1
 Purpose:       Shows in the status bar a descriptive explanation of
                the purpose of each menu item.The message
                WM_MENUSELECT is sent when the user starts browsing
                the menu for each menu item where the mouse passes.
 Input:         Standard windows.
 Output:        The string from the resources string table is shown
 Errors:        If the string is not found nothing will be shown.
------------------------------------------------------------------------*/
//LRESULT MsgMenuSelect(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
//{
//    static char szBuffer[256];
//    UINT   nStringID = 0;
//    UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
//    UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
//    HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);
//
//    szBuffer[0] = 0;                            // First reset the buffer
//    if (fuFlags == 0xffff && hMenu == NULL)     // Menu has been closed
//        nStringID = 0;
//
//    else if (fuFlags & MFT_SEPARATOR)           // Ignore separators
//        nStringID = 0;
//
//    else if (fuFlags & MF_POPUP)                // Popup menu
//    {
//        if (fuFlags & MF_SYSMENU)               // System menu
//            nStringID = IDS_SYSMENU;
//        else
//            // Get string ID for popup menu from idPopup array.
//            nStringID = 0;
//    }  // for MF_POPUP
//    else                                        // Must be a command item
//        nStringID = uCmd;                       // String ID == Command ID
//
//    // Load the string if we have an ID
//    if (0 != nStringID)
//        LoadString(hInst, nStringID, szBuffer, sizeof(szBuffer));
//    // Finally... send the string to the status bar
//    UpdateStatusBar(szBuffer, 0, 0);
//    return 0;
//}

/*------------------------------------------------------------------------
 Procedure:     InitializeStatusBar ID:1
 Purpose:       Initialize the status bar
 Input:         hwndParent: the parent window
                nrOfParts: The status bar can contain more than one
                part. What is difficult, is to figure out how this
                should be drawn. So, for the time being only one is
                being used...
 Output:        The status bar is created
 Errors:
------------------------------------------------------------------------*/
void InitializeStatusBar(HWND hwndParent,int nrOfParts)
{
//    const cSpaceInBetween = 8;
    int   ptArray[40];   // Array defining the number of parts/sections
    RECT  rect;
    HDC   hDC;

   /* * Fill in the ptArray...  */

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right;
    //---TODO--- Add code to calculate the size of each part of the status
    // bar here.

    ReleaseDC(hwndParent, hDC);
    SendMessage(hwndStatusBar,
                SB_SETPARTS,
                nrOfParts,
                (LPARAM)(LPINT)ptArray);

    UpdateStatusBar("Ready", 0, 0);
    //---TODO--- Add code to update all fields of the status bar here.
    // As an example, look at the calls commented out below.

//    UpdateStatusBar("Cursor Pos:", 1, SBT_POPOUT);
//    UpdateStatusBar("Time:", 3, SBT_POPOUT);
}


/*------------------------------------------------------------------------
 Procedure:     CreateSBar ID:1
 Purpose:       Calls CreateStatusWindow to create the status bar
 Input:         hwndParent: the parent window
                initial text: the initial contents of the status bar
 Output:
 Errors:
------------------------------------------------------------------------*/
static BOOL CreateSBar(HWND hwndParent,char *initialText,int nrOfParts)
{
    hwndStatusBar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,
		initialText,hwndParent,IDM_STATUSBAR);
    if(hwndStatusBar)
    {
        InitializeStatusBar(hwndParent,nrOfParts);
        return TRUE;
    }

    return FALSE;
}

static BOOL InitWndClass(void) {
	WNDCLASS wc;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)0;//Brush[BACKBRUSH];
	wc.lpszClassName = "lsmWndClass";
	wc.lpszMenuName = NULL;
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_LARGEICON));
	return (RegisterClass(&wc)==(ATOM)0)?FALSE:TRUE;
}

void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	RECT wRect;
	switch(id) {
		// ---TODO--- Add new menu commands here
		/*@@NEWCOMMANDS@@*/
		case IDM_LOCKHIGH:
			if(ActiveProject) LockHighlight();
		break;
		case IDM_LOCKMARK:
			if(ActiveProject) LockMarked();
		break;
		case IDM_SELECT:
			if(ActiveProject) SetMouseMode(MM_NOTHING);
		break;
		case IDM_PANVIEW:
			if(ActiveProject) SetMouseMode(MM_PANVIEW0);
		break;
		case IDM_ZOOMVIEW:
			if(ActiveProject) SetMouseMode(MM_ZOOMVIEW0);
		break;
		case IDM_ROTVIEW:
			if(ActiveProject) SetMouseMode(MM_ROTVIEW0);
		break;
		case IDM_ADDVERT:
			if(ActiveProject) {
//				ClipDeltaChain(ActiveProject);
				SetMouseMode(MM_ADDVERT);
			}
		break;
		case IDM_ADDMESH:
			if(ActiveProject) {
				ClearAll();
    			BlankSelection();
//				ClipDeltaChain(ActiveProject);
				SetMouseMode(MM_ADDMESH0);
      		}
		break;
		case IDM_ADDPART:
			if(ActiveProject) {
//				ClipDeltaChain(ActiveProject);
				SetMouseMode(MM_ADDPART0);
			}
		break;

		case IDM_SETGRID:	SetGridSnap(hwnd);	break;
		case IDM_SHARPEDGES:	SharpenEdges();	break;
		case IDM_SMOOTHEDGES:	SmoothEdges();	break;
		case IDM_TOGGLEHIGH:	ToggleHighlight();	break;
//		case IDM_IMPORT:	ImportProject();	break;
		case IDM_CLOSE:	CloseActiveProject();	break;
		case IDM_EXPORT:	ExportProject();	break;
		case IDM_PREVPROJ:	ActivatePrevProject();	break;
		case IDM_NEXTPROJ:	ActivateNextProject();	break;
		case IDM_SAVE:	SaveProject(FALSE);	break;
		case IDM_SAVEAS:	SaveProject(TRUE);	break;
		case IDM_OPEN:	OpenProject();	break;
		case IDM_MATRIX:	MatrixMarked(hwnd,EA_NADA);	break;
		case IDM_TRANSLATE:	TranslateMarked(hwnd,EA_NADA);	break;
		case IDM_SCALE:	ScaleMarked(hwnd,EA_NADA);	break;
		case IDM_ROTATE:	RotateMarked(hwnd,EA_NADA);	break;
		case IDM_DETVERT:	DetachMarked();	break;
		case IDM_ATTVERT:	SetMouseMode(MM_HOOKVERT);	break;
		case IDM_MARKALL:	MarkAll();	break;
		case IDM_MARKCLR:	ClearAll();	break;
		case IDM_MARKTOG:	ToggleAll();	break;
		case IDM_PROPERTIES:	EditHighlight(hwnd);	break;
		case IDM_ALIGN_X:	AlignMarked(hwnd,X);	break;
		case IDM_ALIGN_Y:	AlignMarked(hwnd,Y);	break;
		case IDM_ALIGN_Z:	AlignMarked(hwnd,Z);	break;
		case IDM_EXTRUDE:
			if(ActiveProject!=NULL) {
				GetWindowRect(hwnd,&wRect);
				TrackPopupMenuEx(GetSubMenu(ExtrudePopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
					wRect.left+lX,wRect.top+lY,hwnd,NULL);
			}
		break;
		case IDM_COPY:
			if(ActiveProject!=NULL) {
				GetWindowRect(hwnd,&wRect);
				TrackPopupMenuEx(GetSubMenu(CopyPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
					wRect.left+lX,wRect.top+lY,hwnd,NULL);
			}
		break;
		case IDM_EXT_STAY:
			ExtrudeMarked();
		break;
		case IDM_EXT_SCALE:
			ScaleMarked(hwnd,EA_EXTRUDE);
		break;
		case IDM_EXT_ROTATE:
			RotateMarked(hwnd,EA_EXTRUDE);
		break;
		case IDM_EXT_TRANSLATE:
			TranslateMarked(hwnd,EA_EXTRUDE);
		break;
		case IDM_EXT_MATRIX:
			MatrixMarked(hwnd,EA_EXTRUDE);
		break;
		case IDM_COPY_STAY:
			CopyMarked();
		break;
		case IDM_COPY_SCALE:
			ScaleMarked(hwnd,EA_COPY);
		break;
		case IDM_COPY_ROTATE:
			RotateMarked(hwnd,EA_COPY);
		break;
		case IDM_COPY_TRANSLATE:
			TranslateMarked(hwnd,EA_COPY);
		break;
		case IDM_COPY_MATRIX:
			MatrixMarked(hwnd,EA_COPY);
		break;
		case IDM_DELETE:
			if(ActiveProject!=NULL) {
				GetWindowRect(hwnd,&wRect);
				TrackPopupMenuEx(GetSubMenu(DelPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				wRect.left+lX,wRect.top+lY,hwnd,NULL);
			}
		break;
		case IDM_DELVERTS: if(ActiveProject) DeleteVerts(TRUE); break;
		case IDM_DELEDGES: if(ActiveProject) DeleteEdges(TRUE); break;
		case IDM_DELFACES: if(ActiveProject) DeleteFaces(FALSE); break;
		case IDM_DELHIGH: if(ActiveProject) DeleteHighlight(FALSE); break;
		case IDM_DETHIGH: if(ActiveProject) DetachHighlight(FALSE); break;
		case IDM_ATTHIGH: if(ActiveProject) AttachHighlight(FALSE); break;
//		case IDM_JOIN:
//			if(ActiveProject) { MergeMarked(); InvalidateView(); }
//		break;
		case IDM_NEWMODEL:
			CreateModel();
			ActivateFirstProject();
		break;
		case IDM_TOGGLEAXES:
			if(ActiveProject) {
				ActiveProject->Flags^=PF_SHOWAXES;
				InvalidateView();
				UpdateModelMenu();
				UpdateToolBar();
			}
		break;
		case IDM_VIEWXY:	ViewXY();	break;
		case IDM_VIEWXZ:	ViewXZ();	break;
		case IDM_VIEWYZ:	ViewYZ();	break;
		case IDM_ZOOMIN:	ZoomInTenPercent();	break;
		case IDM_ZOOMOUT:	ZoomOutTenPercent();	break;
		case IDM_ZOOMFIT:	Zoom2Fit(ActiveProject);	break;
		case IDM_JUMPORG:	Jump2Origin();	break;
		case IDM_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(DLG_ABOUT), hwndMain,AboutDlg);
		break;
		case IDM_MESHMODE:	EnterMode(EM_MESHEDIT); break;
		case IDM_MAPMODE:	EnterMode(EM_MAPEDIT); break;
		case IDM_ADDTEXTURE:	EditFaceTint(); break;
		case IDM_ADDMAPPING:
			if(HighItem.f)
			if(HighItem.f->MapA==NULL)
			AddMapping(NULL,HighItem.f,TRUE);
			InvalidateView();
		break;
		case IDM_REMMAPPING:
			if(HighItem.f)
			if(HighItem.f->MapA) {
				RemMapping(HighItem.f,FALSE);
			}
			InvalidateView();
		break;
		case IDM_EDITMAPPING:
			if(HighType==HT_FACE)
			if(HighItem.f->MapA) {
				((PMODEL)ActiveProject)->CurTint=HighItem.f->Texture;
				EnterMode(EM_MAPEDIT);
			}
		break;
		case IDM_DEFTINT:	CurTintHighFace();	InvalidateView();	break;
		case IDM_SHOWPARTS:
			if(ActiveProject) {
				ActiveProject->Flags^=MF_SHOWPARTS;
				InvalidateView();
				UpdateModelMenu();
				UpdateToolBar();
			}
		break;

		case IDM_SHOWVERTS:
			if(ActiveProject) {
				ActiveProject->Flags^=MF_SHOWVERTS;
				InvalidateView();
				UpdateModelMenu();
				UpdateToolBar();
			}
		break;

		case IDM_SHOWEDGES:
			if(ActiveProject) {
				ActiveProject->Flags^=MF_SHOWEDGES;
				InvalidateView();
				UpdateModelMenu();
				UpdateToolBar();
			}
		break;

		case IDM_SHOWFACES:
			if(ActiveProject) {
				ActiveProject->Flags^=MF_SHOWFACES;
				InvalidateView();
				UpdateModelMenu();
				UpdateToolBar();
			}
		break;
		case IDM_UNDO:
			Undo(ActiveProject);
			InvalidateView();
		break;
		case IDM_REDO:
			Redo(ActiveProject);
			InvalidateView();
		break;

		case IDM_MAKE_UNI:
			ConvertJoint(HighItem.p,PT_UNI);
		break;
		case IDM_MAKE_BALL:
			ConvertJoint(HighItem.p,PT_BALL);
		break;
		case IDM_MAKE_HINGE:
			ConvertJoint(HighItem.p,PT_HINGE);
		break;

		case IDM_PANIC:
			ShellExecute(hwnd,NULL,"lsm.htm",NULL,NULL,SW_SHOW);
		break;
		case IDM_EXIT:
		PostMessage(hwnd,WM_CLOSE,0,0);
		break;
	}
}

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	HMENU tpu;
	TOOLTIPTEXT *tipinfo;
//	NMHDR	*header;

	switch (msg) {
	case WM_PAINT: RedoDisplay(); break;
	case WM_MOUSEMOVE: MouseMove(hwnd,wParam,lParam); break;
	case WM_LBUTTONDOWN: LeftClick(hwnd,wParam,lParam); break;
	case WM_LBUTTONDBLCLK: LeftDoubleClick(hwnd,wParam,lParam); break;
	case WM_LBUTTONUP: LeftRelease(hwnd,wParam,lParam); break;
	case WM_RBUTTONDOWN: RightClick(hwnd,wParam,lParam); break;
	case WM_RBUTTONUP:
		RightRelease(hwnd,wParam,lParam);
		if(Popup) return DefWindowProc(hwnd,msg,wParam,lParam);
	break;
	case WM_CONTEXTMENU:
		if(ActiveProject!=NULL)
		switch(HighType) {
			case HT_PART:
				TrackPopupMenuEx(GetSubMenu(PartPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
			break;
			case HT_KNOB:
				TrackPopupMenuEx(GetSubMenu(KnobPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
			break;
			case HT_EDGE:
				TrackPopupMenuEx(GetSubMenu(EdgePopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
			break;
			case HT_VERT:
				TrackPopupMenuEx(GetSubMenu(VertPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
			break;
			case HT_UVPT:
				TrackPopupMenuEx(GetSubMenu(UVPtPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
			break;
			case HT_FACE:
				tpu=BuildTintPopup((PMODEL)ActiveProject);
				TrackPopupMenuEx(tpu,TPM_LEFTALIGN|TPM_LEFTBUTTON,
				LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
				DestroyMenu(tpu);
			break;
			default:
				switch(ActiveProject->EditMode) {
	    			case EM_MESHEDIT:
						TrackPopupMenuEx(GetSubMenu(PopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
						LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
					break;
	    			case EM_MAPEDIT:
						TrackPopupMenuEx(GetSubMenu(MapPopupMenu,0),TPM_LEFTALIGN|TPM_LEFTBUTTON,
						LOWORD(lParam),HIWORD(lParam),hwnd,NULL);
					break;
				}
			}
	break;
	case WM_KILLFOCUS:	// if window loses focus
	case WM_CANCELMODE:	// or an unexpected dialog pops up
		RightClick(hwnd,wParam,lParam);
		RightRelease(hwnd,wParam,lParam);
	break;
	case WM_HSCROLL: HScroll(wParam); break;
	case WM_VSCROLL: VScroll(wParam); break;
	case WM_CLOSE:
		if(DestroyAllProjects()) {
			SetWindowText(hwndMain,NULL);
			DestroyString(WindowTitle);
			DeleteAppData();
			DestroyWindow(hwndMain);
		}
	break;
	case WM_SIZE:
		SendMessage(hwndStatusBar,msg,wParam,lParam);
		InitializeStatusBar(hwndStatusBar,1);
		SendMessage(hwndToolBar, TB_AUTOSIZE, 0, 0);
		if(hrc) {
			wglDeleteContext(hrc);
			hrc=NULL;
		}
		ResizeDisplay();
		InvalidateView();
	break;
//	case WM_MENUSELECT:
//		return MsgMenuSelect(hwnd,msg,wParam,lParam);
	case WM_COMMAND:
		HANDLE_WM_COMMAND(hwnd,wParam,lParam,MainWndProc_OnCommand);
	break;
	case WM_DESTROY:
	    glDeleteLists(ListStart,0x60);
		wglMakeCurrent(NULL,NULL);
		if(hrc) {
			wglDeleteContext(hrc);
			hrc=NULL;
		}
		PostQuitMessage(0);
	break;
	case WM_HELP:
			switch((int)ShellExecute(hwnd,"open","lsm.htm",NULL,NULL,SW_SHOW)) {
				case ERROR_FILE_NOT_FOUND:
					MessageBoxEx(hwnd,"File \42lsm.htm\42 not found","Error",MB_OK,0);
				break;
			}
	break;
	case WM_CREATE:
		InvalidateView();
	break;
	case WM_NOTIFY:
		tipinfo=(LPTOOLTIPTEXT)lParam;
//		header=(LPNMHDR)lParam;

/*
// make sure customization works
    if (header->code == TBN_QUERYINSERT
		|| header->code == TBN_QUERYDELETE
//		|| header->code == TBN_DELETINGBUTTON
		|| header->code == TBN_BEGINDRAG
		|| header->code == TBN_ENDDRAG
		|| header->code == TBN_BEGINADJUST
//		|| header->code == TBN_INITCUSTOMIZE
  )
	return TRUE;
*/
    if ((int)(tipinfo->hdr.code) == (int)TTN_NEEDTEXT) {
        tipinfo->hinst = hInst;
        tipinfo->lpszText = MAKEINTRESOURCE(tipinfo->hdr.idFrom);
    }
	return 0;

//		tipinfo->hinst=hInst;
//		tipinfo->lpszText=(LPTSTR)(tipinfo->hdr.idFrom);
	break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
/*@@3<-@@*/
	return 0;
}
/*@@2<-@@*/

/*<---------------------------------------------------------------------->*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	hInst = hInstance;

	CreateAppData();
	if(InitWndClass()==FALSE) return 0;
	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	hwndMain=CreateWindow("lsmWndClass",NULL,WS_TILEDWINDOW|WS_VISIBLE|
		WS_VSCROLL|WS_HSCROLL|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,
		CW_USEDEFAULT,0,CW_USEDEFAULT,0,NULL,NULL,hInst,NULL);
	if (hwndMain==(HWND)0) return 0;
	CreateSBar(hwndMain,"Ready",1);
	hwndToolBar=CreateAToolBar(hwndMain,hInst);
	SetMenu(hwndMain,LameMenu);
	ShowWindow(hwndMain,SW_SHOW);
	SetWindowTitle();
	OpenFromCommandLine(lpCmdLine);
	PostMessage(hwndMain,WM_PAINT,0,0);
	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateAccelerator(msg.hwnd,hAccelTable,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}
