#include "data.h"

extern chain Projects;

extern PPROJECT ActiveProject;

PMODEL CreateModel(void /*char *Name*/) {
	PMODEL m;
//	register short i;

	m=(PMODEL)malloc(sizeof(MODEL));

	if(m!=(PMODEL)NULL) {
		InitProject((PPROJECT)m);
		m->Project.Flags=PF_SHOWAXES|PF_INVALIDVIEW|MF_SHOWPARTS|MF_SHOWVERTS
			|MF_SHOWEDGES|MF_SHOWFACES;
		m->Project.ProjectType=PT_MODEL;
		m->Project.SaveTitle=CreateModelName();
		m->Project.EditMode=EM_MESHEDIT;
		initChain(&m->Vertices);
		initChain(&m->Parts);
		initChain(&m->Edges);
		initChain(&m->Knobs);
		initChain(&m->Faces);
		initChain(&m->Tints);
		initChain(&m->UVPts);
		m->NextEdgeIndex=m->NextFaceIndex=m->NextKnobIndex=m->NextPartIndex=
  		m->NextUVPtIndex=m->NextVertIndex=0;
		m->NextTintIndex=(INDEX)-1;
//		InitChain(&m->Normals);
//		InitChain(&m->CrossRefs);
		m->defTint=CreateTint(m,0xa0a0a0,FALSE);
		free(m->defTint->Name);
		m->defTint->Name=CloneString("none");
		m->CurTint=m->defTint;
		m->MeshSnap=m->MapSnap=.001;
	}
	return m;
}

void DestroyModelInfo(PMODEL m) {
	if(m) {
		while(m->Faces.pop) DestroyFace(FIRSTFACE(m),FALSE);
		while(m->UVPts.pop) DestroyUVPt(FIRSTUVPT(m),FALSE);
		while(m->Tints.pop) DestroyTint(FIRSTTINT(m),FALSE);

		while(m->Edges.pop) DestroyEdge(FIRSTEDGE(m),FALSE);
		while(m->Vertices.pop) DestroyVertex(FIRSTVERT(m),FALSE);

		while(m->Parts.pop) DestroyPart(FIRSTPART(m),FALSE);
		while(m->Knobs.pop) DestroyKnob(FIRSTKNOB(m),FALSE);
//		while(m->Normals.Count) DestroyNormal(FIRSTNORM(m),FALSE);
//		while(m->CrossRefs.Count) DestroyCrossRef(FIRSTXREF(m),FALSE);
	}
}

PMODEL FindModel(link *l) {
	chain *c;
	PMODEL m;

	if(l==NULL)
		ReportSystemError("Tried to find model of NULL pointer");

	c=findChain(l);

	m=(PMODEL)(Projects.Next);
	while(NEXT(m)!=NULL) {
		if((&m->Vertices==c)||(&m->Parts==c)||(&m->Tints==c)
		||(&m->Knobs==c)||(&m->Faces==c)||(&m->Edges==c)|| (&m->UVPts==c)
		/* ||(&m->Normals==c)||(&m->CrossRefs==c) */ ) return m;
		m=(PMODEL)(NEXT(m));
	}
	return (PMODEL)NULL;
}

void ReindexModelObjects(PMODEL m) {
	INDEX i;
	MYPTR mp;

	i=0;
	STEPVERTS(m,mp.v) mp.v->Index=i++;
	m->NextVertIndex=i;

	i=0;
	STEPEDGES(m,mp.e) mp.e->Index=i++;
	m->NextEdgeIndex=i;

	i=0;
	STEPFACES(m,mp.f) mp.f->Index=i++;
	m->NextFaceIndex=i;

	i=0;
	STEPKNOBS(m,mp.k) mp.k->Index=i++;
	m->NextKnobIndex=i;

	i=0;
	STEPPARTS(m,mp.p) mp.p->Index=i++;
	m->NextPartIndex=i;

	i=0;
	STEPTINTS(m,mp.t)
	if(mp.t!=m->defTint)
	mp.t->Index=i++;
	m->defTint->Index=(INDEX)-1;
	m->NextTintIndex=i;

	i=0;
	STEPUVPTS(m,mp.u) mp.u->Index=i++;
	m->NextUVPtIndex=i;

}

edge* IndexEdge(PMODEL m,INDEX i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (edge*)(index(&m->Edges,i));
}

face* IndexFace(PMODEL m,INDEX i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (face*)(index(&m->Faces,i));
}

knob *IndexKnob(PMODEL m,ULONG i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (knob*)(index(&m->Knobs,i));
}

part* IndexPart(PMODEL m,ULONG i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (part*)(index(&m->Parts,i));
}

tint *IndexTint(PMODEL m,ULONG i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	if(i==(INDEX)-1) return m->defTint;
	return (tint*)(index(&m->Tints,i));
}

uvpt* IndexUVPt(PMODEL m,INDEX i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (uvpt*)(index(&m->UVPts,i));
}

vert* IndexVert(PMODEL m,INDEX i) {
	if(m==NULL) m=(PMODEL)ActiveProject;
	return (vert*)(index(&m->Vertices,i));
}

vert* SelectVert(PMODEL m,ULONG i) {
	vert* v;

	if(m==NULL) m=(PMODEL)ActiveProject;

	STEPVERTS(m,v)
	if(v->Select==i) return v;

	return NULL;
}

