/*#include "data.h"
#include <stdio.h>

extern PPROJECT ActiveProject;
extern HWND hwndMain;
extern char NumBuff[];
extern char InputBuffer[];
extern BOOL EndOfFile;
extern BYTE CCR[];
extern BYTE Comma[];
extern OPENFILENAME FileData;
extern void **XRefTable;

BYTE PCMHeader[7]={ 34,80,67,77,49,34,0 };

PMODEL ReadPCMFile(HANDLE fhand) {
	PMODEL m;
	INDEX i,count,smooth;
	PVERT va,vb,vc;
	PFACE f,of;
	PXREF x,ox;
	PEDGE e;

	m=CreateModel();
	m->Project.SaveTitle=CloneString(FileData.lpstrFileTitle);

	EndOfFile=FALSE;

	Read2Comma(fhand);
	if (strcmp(PCMHeader,InputBuffer)!=0) {
		BogusPCMFile(m);
		return NULL;
	}

	Read2Comma(fhand);	// get the number of vectors defined
	count=atoi(InputBuffer);
	if(count==0) { BogusPCMFile(m); return NULL; }

// makes it this far

	for (i=0;i<count;i++) {
		va=CreateVertex(m,0,0);
		va->Flags=TF_MARKED;	// not used as a corner
		va->Index=i;
		Read2Comma(fhand);
		va->Spot[X]=(float)atof(InputBuffer);
		Read2Comma(fhand);
		va->Spot[Y]=(float)atof(InputBuffer);
		Read2Comma(fhand);
		va->Spot[Z]=(float)atof(InputBuffer);
	}

	ReportSystemError("Vectors and normals read in.");

	Read2Comma(fhand);	// get the number of flat triangles defined
	count=atoi(InputBuffer);
	Read2Comma(fhand);	// get the number of smooth triangles defined
	smooth=atoi(InputBuffer);

	XRefTable=malloc(sizeof(void *)*(count+smooth));

	for (i=0;i<count;i++) {
		Read2Comma(fhand);
		va=IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		vb=IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		vc=IndexVert(m,atoi(InputBuffer));
		f=CreateFace(m,va,vb,vc,NULL);
		f->Index=i;
		f->EdgeE->Flags|=TF_SHARP;	// flat faces always have sharp edges
		f->EdgeG->Flags|=TF_SHARP;
		f->EdgeF->Flags|=TF_SHARP;
		f->VertA->Flags|=TF_SHARP;	// flat faces always have sharp vertices
		f->VertA->Flags|=TF_SHARP;
		f->VertB->Flags|=TF_SHARP;
		va->Flags&=~TF_MARKED;	// used as a corner, will not be deleted
		vb->Flags&=~TF_MARKED;
		vc->Flags&=~TF_MARKED;
		XRefTable[i]=NULL;
	}

	ReportSystemError("Flat faces read in.");

	for (i=0;i<smooth;i++) {
		XRefTable[i+count]=x=CreateCrossRef(m);
		Read2Comma(fhand);
		va=IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		x->NormA=(PNORM)IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		vb=IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		x->NormB=(PNORM)IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		vc=IndexVert(m,atoi(InputBuffer));
		Read2Comma(fhand);
		x->NormC=(PNORM)IndexVert(m,atoi(InputBuffer));
		f=CreateFace(m,va,vb,vc,NULL);
		f->Index=i+count;
		va->Flags&=~TF_MARKED;
		vb->Flags&=~TF_MARKED;
		vc->Flags&=~TF_MARKED;
		((PVERT)(x->NormA))->Flags|=TF_DRAGGED;
		((PVERT)(x->NormB))->Flags|=TF_DRAGGED;
		((PVERT)(x->NormC))->Flags|=TF_DRAGGED;
	}

	ReportSystemError("Smooth faces read in.");

// now here we have code to determine the sharpening of edges that
// lie between two smooth triangles
	STEPEDGES(m,e) {
		f=e->FaceL;
		of=e->FaceR;
		if((e->Flags&TF_SHARP)==0 && f!=NULL && of!=NULL) {
			x=XRefTable[f->Index];
			ox=XRefTable[of->Index];

			va=e->VertS;
			if(f->VertA==va) vb=(PVERT)(x->NormA);
			if(f->VertB==va) vb=(PVERT)(x->NormB);
			if(f->VertC==va) vb=(PVERT)(x->NormC);
			if(of->VertA==va) vc=(PVERT)(ox->NormA);
			if(of->VertB==va) vc=(PVERT)(ox->NormB);
			if(of->VertC==va) vc=(PVERT)(ox->NormC);

		// code here to compare vb and vc
		// I've decided that normals will be re-used instead of being
		// duplicated
			if(vb->Index!=vc->Index) {
				e->Flags|=TF_SHARP;
			} else {
				va=e->VertE;
				if(f->VertA==va) vb=(PVERT)(x->NormA);
				if(f->VertB==va) vb=(PVERT)(x->NormB);
				if(f->VertC==va) vb=(PVERT)(x->NormC);
				if(of->VertA==va) vc=(PVERT)(ox->NormA);
				if(of->VertB==va) vc=(PVERT)(ox->NormB);
				if(of->VertC==va) vc=(PVERT)(ox->NormC);

				if(vb->Index!=vc->Index)
				e->Flags|=TF_SHARP;
			}
		}

		if(e->Flags&TF_SHARP) {
			e->VertS->cX++;
			e->VertE->cX++;
		}
	}

	ReportSystemError("Edge sharpening done.");

// then we go through and uncheck the sharp flag of all vertices which
// have three or more sharp edges meeting at them.
// This is done on the assumption that the vertex was deemed sharp on
// account of the three sharp edges, and not the user-set flag
// cX and cY are set to zero upon vertex creation earlier in the function,
// so there is no need to clear them here
	STEPVERTS(m,va)
	if(va->cX>2)
	va->Flags&=~TF_SHARP;

	ReportSystemError("Vertex sharpening done.");

// then we go through and destroy all vertices which were used as normals
// but not specified to be the corner of any face.

	va=FIRSTVERT(m);
	while((vb=(PVERT)NEXT(va))!=NULL) {
		if((va->Flags&(TF_MARKED|TF_DRAGGED))==(TF_MARKED|TF_DRAGGED))
		DestroyVertex(va,FALSE);
		va=vb;
	}

	ReportSystemError("Excess vertex destruction done.");

	STEPVERTS(m,va)
	va->Flags&=~(TF_MARKED|TF_DRAGGED);

	ReportSystemError("Vertices cleared.");

// then we get rid of the cross-references table
	for(i=0;i<(count+smooth);i++)
	DestroyCrossRef(XRefTable[i],FALSE);
	free(XRefTable);

	ReportSystemError("Cross-reference table freed.");

	return m;
}

void WritePCMFile(HANDLE fhand,PMODEL m) {
	PVERT v;
	PNORM n;
	PFACE f;
	PXREF x;
	ULONG many;
	VECTOR vec;
	long cf,cs;

	OrderAllVertices(m);
	BuildAllNormals(m);

	WriteString(fhand,PCMHeader);
	WriteString(fhand,CCR);
	WriteIntegerString(fhand,m->Vertices.Count+m->Normals.Count);
	WriteString(fhand,CCR);

	many=0;
	STEPVERTS(m,v) {
		WriteFloatString(fhand,v->Spot[X]);
		WriteString(fhand,Comma);
		WriteFloatString(fhand,v->Spot[Y]);
		WriteString(fhand,Comma);
		WriteFloatString(fhand,v->Spot[Z]);
		WriteString(fhand,Comma);
		v->Index=many++;
		if((many%3)==0) WriteCR(fhand);
	}

	STEPNORMS(m,n) {
		CalcNormal(n,vec);
		WriteFloatString(fhand,vec[X]);
		WriteString(fhand,Comma);
		WriteFloatString(fhand,vec[Y]);
		WriteString(fhand,Comma);
		WriteFloatString(fhand,vec[Z]);
		WriteString(fhand,Comma);
		n->Index=many++;
		if((many%3)==0) WriteCR(fhand);
	}

	if((many%3)!=0) WriteCR(fhand);

	cf=cs=0;
	STEPFACES(m,f)
	if((f->Flags&TF_SHARP)==0) {
		cf++;
	} else {
		cs++;
	}
// code here to calculate the number of flat vs smooth faces
	WriteIntegerString(fhand,cf);
	WriteString(fhand,Comma);
	WriteIntegerString(fhand,cs);
	WriteString(fhand,CCR);

	many=0;
	STEPFACES(m,f)
	if((f->Flags&TF_SHARP)!=0) {
		WriteIntegerString(fhand,f->VertA->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,f->VertB->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,f->VertC->Index);
		WriteString(fhand,Comma);
		many++;
		if((many%7)==0) WriteCR(fhand);
	}

	STEPFACES(m,f)
	if((f->Flags&TF_SHARP)==0) {
		x=(PXREF)(XRefTable[f->Index]);
		WriteIntegerString(fhand,f->VertA->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,x->NormA->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,f->VertB->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,x->NormB->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,f->VertC->Index);
		WriteString(fhand,Comma);
		WriteIntegerString(fhand,x->NormC->Index);
		WriteString(fhand,Comma);
		many++;
		if((many%3)==0) WriteCR(fhand);
	}
	if((many%3)!=0) WriteCR(fhand);

	DestroyAllNormals(m);
	InvalidateView();
}

void BogusPCMFile(PMODEL m) {
	MessageBoxEx(hwndMain,"This is not a valid PCM format 1 file.",
		"Invalid file",MB_OK,LANG_NEUTRAL);
	DestroyProject((PPROJECT)m);
}
*/

