#include "data.h"
#include <stdio.h>
#include <string.h>

char *WindowTitle=NULL;

char BaseTitleString[]="The LionSnake Modeler";

extern PPROJECT ActiveProject;

extern HWND hwndMain;

extern chain Projects;

char *CreateModelName(void)
{
	char tbuff[20];
	char *name;
	int i;


	for(i=1,name=NULL;name==NULL;i++) {
		sprintf(tbuff,"Model%d",i);
		if(IsUniqueProjectName(tbuff)) name=CloneString(tbuff);
	}
	return name;
}

void DestroyString(char *s) { if(s) free(s); }

char *CloneString(char *s) {
	char *ns;
	ns=(char *)malloc(strlen(s)+1);
	if (ns!=NULL) {
		strcpy(ns,s);
		ns[strlen(s)]=0;
	}
	return ns;
}

void FatFarm(char *s) {
	unsigned int i;
	int p;

	p=-1;
	for (i=0;i<strlen(s);i++) {
		if (s[i]=='E') return; // we don't touch sci notation
		if (s[i]=='e') return; // we don't touch sci notation
		if (s[i]=='.') p=i;
	}
	if (p==-1) return; // there is no decimal

	// strip trailing zeros
	while (s[strlen(s)-1]=='0') s[strlen(s)-1]=0;

	// strip trailing decimal
	if(s[strlen(s)-1]=='.') s[strlen(s)-1]=0;
}

void CopyString(char *s,char *d) {
	short i;

	if(s==0 || d==0) return;

	i=0;
	do {
		d[i]=s[i];
		i++;
	} while(s[i-1]!=0);
}

void SetWindowTitle(void) {
	char *ts;

	if(WindowTitle) {
		DestroyString(WindowTitle);
		WindowTitle=NULL;
	}

	if(ActiveProject==NULL) {
		SetWindowText(hwndMain,BaseTitleString);
		return;
	}

	ts=ConcatStrings(BaseTitleString," - ");

	WindowTitle=ConcatStrings(ts,ActiveProject->SaveTitle);
	DestroyString(ts);

	SetWindowText(hwndMain,WindowTitle);
}

char *ConcatStrings(char *a,char *b) {
	int la;
	char *s;

	la=strlen(a);

	s=(char *)malloc(la+strlen(b)+1);

	strcpy(s,a);
	strcpy(s+la,b);
	return s;
}

char *CreatePartName(PMODEL m) {
	char tbuff[20];
	char *name;
	int i;

	for(i=1,name=NULL;name==NULL;i++) {
		sprintf(tbuff,"Part%d",i);
		if(IsUniquePartName(m,tbuff,(part*)NULL)) name=CloneString(tbuff);
	}
	return name;
}

char *CreateTintName(PMODEL m) {
	char tbuff[20];
	char *name;
	int i;

	for(i=1,name=NULL;name==NULL;i++) {
		sprintf(tbuff,"Texture%d",i);
		if(IsUniqueTintName(m,tbuff,NULL)) name=CloneString(tbuff);
	}
	return name;
}

BOOL IsUniqueProjectName(char *n) {
	PPROJECT p;

	for(p=(PPROJECT)(Projects.Next);p->Link.Next!=NULL;p=(PPROJECT)p->Link.Next)
	if(p->SaveTitle)
	if(strcmp(p->SaveTitle,n)==0) return FALSE;

    return TRUE;
}

BOOL IsUniquePartName(PMODEL m,char *n,part* ex) {
	part* p;

	STEPPARTS(m,p)
	if(p!=ex)
	if(p->Name)
	if(strcmp(p->Name,n)==0) return FALSE;

    return TRUE;
}

BOOL IsUniqueTintName(PMODEL m,char *n,tint *ex) {
	tint *t;

	STEPTINTS(m,t)
	if(t!=ex)
	if(t->Name)
	if(strcmp(t->Name,n)==0) return FALSE;

    return TRUE;
}

void ScrubString(char *src,char find,char replace,char *dst) {
    int i;
    int j;
    
    for(i=0,j=0;src[i]!=0;i++) {
        if(src[i]==find) {
                dst[j]=replace;
                if(replace!=0) j++;
        } else {
                dst[j]=src[i];
                j++;
        }
    }
    dst[j]=0;
}


