#include "lsmres.h"
#include "data.h"
#include <commctrl.h>

#define MAX_LEN 32

#define TB_COUNT 27

extern PPROJECT ActiveProject;

extern short MouseMode;

int tbBitMap[TB_COUNT]={
	STD_FILENEW,	STD_FILESAVE,	STD_FILEOPEN,	-1,			STD_UNDO,
	STD_REDOW,		-1,				STD_COPY,		STD_DELETE,	-1,
	0,				1,				2,				3,			4,
	-1,				5,				6,				7,			-1,
	8,				9,				10,				11,			12,
	13,				14
};

int tbCommand[TB_COUNT]={
	IDM_NEWMODEL,	IDM_SAVE,	IDM_OPEN,	0,				IDM_UNDO,
	IDM_REDO,		0,			IDM_COPY,	IDM_DELETE,		0,
	IDM_SHOWVERTS,	IDM_SHOWEDGES,	IDM_SHOWFACES,	IDM_SHOWPARTS,	IDM_TOGGLEAXES,
	0,	IDM_VIEWXY,	IDM_VIEWXZ,	IDM_VIEWYZ,	0,
	IDM_SELECT,	IDM_PANVIEW,	IDM_ZOOMVIEW,	IDM_ROTVIEW,	IDM_ADDVERT,
	IDM_ADDMESH,	IDM_ADDPART
};

BYTE tbState[TB_COUNT]={
	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	0,	0, //undo
	0,	0,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	0,
	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,
	0,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	0,
	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,	TBSTATE_ENABLED,
	TBSTATE_ENABLED,	TBSTATE_ENABLED
};

BYTE tbStyle[TB_COUNT]={
	TBSTYLE_BUTTON,	TBSTYLE_BUTTON,	TBSTYLE_BUTTON,	TBSTYLE_SEP,	TBSTYLE_BUTTON,
	TBSTYLE_BUTTON,	TBSTYLE_SEP,	TBSTYLE_BUTTON,	TBSTYLE_BUTTON,	TBSTYLE_SEP,
	TBSTYLE_CHECK,	TBSTYLE_CHECK,	TBSTYLE_CHECK,	TBSTYLE_CHECK,	TBSTYLE_CHECK,
	TBSTYLE_SEP,	TBSTYLE_BUTTON,	TBSTYLE_BUTTON,	TBSTYLE_BUTTON,	TBSTYLE_SEP,
	TBSTYLE_CHECKGROUP,	TBSTYLE_CHECKGROUP,	TBSTYLE_CHECKGROUP,	TBSTYLE_CHECKGROUP,	TBSTYLE_CHECKGROUP,
	TBSTYLE_CHECKGROUP,	TBSTYLE_CHECKGROUP
};

extern HWND hwndToolBar;

// CreateAToolBar creates a toolbar and adds a set of buttons to it.
// The function returns the handle to the toolbar if successful,
// or NULL otherwise.
// hwndParent is the handle to the toolbar's parent window.
HWND CreateAToolBar(HWND hwndParent,HINSTANCE hInst) {
   HWND hwndTB;
	TBBUTTON tbb;
   TBADDBITMAP tbab;
   INITCOMMONCONTROLSEX icex;
   int hr;
	int i;

// Ensure that the common control DLL is loaded.
   icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
   icex.dwICC  = ICC_BAR_CLASSES;
   InitCommonControlsEx(&icex);

// Create a toolbar.
	hwndTB = CreateWindowEx(0, TOOLBARCLASSNAME, (LPSTR) NULL, WS_CHILD |
		TBSTYLE_TOOLTIPS | /*CCS_ADJUSTABLE |*/ TBSTYLE_WRAPABLE, 0, 0, 0, 0,
		hwndParent, (HMENU) ID_TOOLBAR, hInst, NULL);

// Send the TB_BUTTONSTRUCTSIZE message, which is required for
// backward compatibility.
	SendMessage(hwndTB, TB_BUTTONSTRUCTSIZE, (WPARAM) sizeof(TBBUTTON), 0);

	SendMessage(hwndTB, TB_SETBUTTONSIZE,0,(LPARAM)MAKELONG(24,22));

// add standard buttons
	tbab.hInst=HINST_COMMCTRL;
	tbab.nID=IDB_STD_SMALL_COLOR;
	SendMessage(hwndTB,TB_ADDBITMAP,0,(LPARAM) (LPTBADDBITMAP) &tbab );
// and my new ones
	tbab.hInst=hInst;
	tbab.nID=IDB_TOOLBAR;
	hr=SendMessage(hwndTB,TB_ADDBITMAP,(WPARAM)5,(LPARAM)(LPTBADDBITMAP)&tbab);

	memset(&tbb,0,sizeof(tbb));

	for(i=0;i<TB_COUNT;i++) {
		tbb.iBitmap=tbBitMap[i];
		if(i>=10 && tbBitMap[i]>=0) tbb.iBitmap+=hr;
		tbb.idCommand=tbCommand[i];
		tbb.fsState=tbState[i];
		tbb.fsStyle=tbStyle[i];
		tbb.dwData=0;
		tbb.iString=-1;
		SendMessage(hwndTB, TB_ADDBUTTONS, (WPARAM) 1,(LPARAM) (LPTBBUTTON)&tbb);
	}

// lefotver code

//	LoadString(hInst, IDS_NEW, szBuf, MAX_LEN-1);
//   tbb[0].iString = -1;//SendMessage(hwndTB, TB_ADDSTRING, (WPARAM) 0, (LPARAM) (LPSTR) szBuf);

	SendMessage(hwndTB,TB_SETMAXTEXTROWS,0,0);

   SendMessage(hwndTB, TB_AUTOSIZE, 0, 0);

   ShowWindow(hwndTB, SW_SHOW);
   return hwndTB;
}

void UpdateToolBar(void) {
	int i;
	BOOL flag;
	char /*check[TB_COUNT],*/ enable[TB_COUNT];

	if(hwndToolBar==(HWND)0) return;

//	for(i=0;i<TB_COUNT;i++) {
//		check[i]=0;
//		if(tbStyle[i]==TBSTYLE_CHECK || tbStyle[i]==TBSTYLE_CHECKGROUP)
//		check[i]=1;
//	}

	if(ActiveProject==NULL) {
		for(i=0;i<TB_COUNT;i++) {
			enable[i]=0;
//			if(check[i]==1) check[i]==-1);
		}
		enable[0]=enable[2]=TRUE;
	} else {
		for(i=0;i<TB_COUNT;i++) {
			enable[i]=tbState[i];
		}
		flag=(ActiveProject->EditMode==EM_MESHEDIT);
		enable[16]=enable[17]=enable[18]=
		enable[23]=enable[24]=enable[25]=enable[26]=flag;

		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SHOWVERTS,
			MAKELONG(ActiveProject->Flags&MF_SHOWVERTS,0));
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SHOWEDGES,
			MAKELONG(ActiveProject->Flags&MF_SHOWEDGES,0));
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SHOWFACES,
			MAKELONG(ActiveProject->Flags&MF_SHOWFACES,0));
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SHOWPARTS,
			MAKELONG(ActiveProject->Flags&MF_SHOWPARTS,0));
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_TOGGLEAXES,
			MAKELONG(ActiveProject->Flags&PF_SHOWAXES,0));

		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SELECT,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_PANVIEW,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ZOOMVIEW,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ROTVIEW,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDVERT,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDMESH,0);
		SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDPART,0);

		switch(MouseMode) {
			case MM_PANVIEW0: case MM_PANVIEW1:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_PANVIEW,MAKELONG(TRUE,0));
			break;
			case MM_ZOOMVIEW0: case MM_ZOOMVIEW1:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ZOOMVIEW,MAKELONG(TRUE,0));
			break;
			case MM_ROTVIEW0: case MM_ROTVIEW1:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ROTVIEW,MAKELONG(TRUE,0));
			break;
			case MM_ADDVERT:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDVERT,MAKELONG(TRUE,0));
			break;
			case MM_ADDMESH0: case MM_ADDMESH1: case MM_ADDMESH2: case MM_ADDMESHX:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDMESH,MAKELONG(TRUE,0));
			break;
			case MM_ADDPART0: case MM_ADDPART1: case MM_ADDPART2: case MM_ADDPARTX:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_ADDPART,MAKELONG(TRUE,0));
			break;
			default:
				SendMessage(hwndToolBar,TB_CHECKBUTTON,IDM_SELECT,MAKELONG(TRUE,0));
			break;
		}
	}
	for(i=0;i<TB_COUNT;i++)
	if(tbCommand[i])
	SendMessage(hwndToolBar,TB_ENABLEBUTTON,tbCommand[i],MAKELONG(enable[i],0));
}

