#include "view.h"
#include <gl/gl.h>

void initView(view* v) {
	initMatrix(v->Orient);
	v->Scale=1.0;
	v->Flags=VF_LEFTHANDED;
}

void loadIntoOpenGL(view* v,int cX,int cY) {
	GLfloat m[16];

	m[ 1]=m[ 2]=m[ 3]=m[ 4]=m[ 6]=m[ 7]=m[ 8]=m[ 9]=0.0;
	m[10]=0.001/v->Scale;
	m[11]=m[12]=m[13]=m[14]=0.0;
	m[15]=1.0;

	if(cX>cY) {
		m[ 0]=1.0/v->Scale*(float)cY/(float)cX;
		m[ 5]=1.0/v->Scale;
	} else {
		m[ 0]=1.0/v->Scale;
		m[ 5]=1.0/v->Scale*(float)cX/(float)cY;
	}
	glMultMatrixf(m);

	m[ 0]=v->Orient[XX];
	m[ 1]=v->Orient[YX];
	m[ 2]=v->Orient[ZX];
	m[ 3]=0.0;
	m[ 4]=v->Orient[XY];
	m[ 5]=v->Orient[YY];
	m[ 6]=v->Orient[ZY];
	m[ 7]=0.0;
	m[ 8]=v->Orient[XZ];
	m[ 9]=v->Orient[YZ];
	m[10]=v->Orient[ZZ];
	m[11]=
	m[12]=
	m[13]=
	m[14]=0.0;
	m[15]=1.0;
	glMultMatrixf(m);

	m[ 0]=1.0;
	m[ 1]=m[ 2]=m[ 3]=m[ 4]=0.0;
	m[ 5]=1.0;
	m[ 6]=m[ 7]=m[ 8]=m[ 9]=0.0;
	m[10]=1.0;
	m[11]=0.0;
	m[12]=-v->Orient[LX];
	m[13]=-v->Orient[LY];
	m[14]=-v->Orient[LZ];
	m[15]=1.0;
	glMultMatrixf(m);
}

void mapScr2XYZ(view* v,short pX,short pY,float* d) {
	float fX=(float)((pX<<1)-v->sX)/(float)v->sM*v->Scale;
	float fY=(float)(v->sY-((pY-v->Screen.top)<<1))/(float)v->sM*v->Scale;
	d[X]=v->Orient[LX] + v->Orient[XX]*fX + v->Orient[YX]*fY;
	d[Y]=v->Orient[LY] + v->Orient[XY]*fX + v->Orient[YY]*fY;
	d[Z]=v->Orient[LZ] + v->Orient[XZ]*fX + v->Orient[YZ]*fY;
}

void mapScr2UV(view* v,short pX,short pY,float *d) {
	float fX=(float)((pX<<1)-v->sX)/(float)v->sM*v->Scale;
	float fY=(float)(v->sY-(pY<<1))/(float)v->sM*v->Scale;
	d[U]=v->Orient[LX] + v->Orient[XX]*fX + v->Orient[YX]*fY;
	d[V]=v->Orient[LY] + v->Orient[XY]*fX + v->Orient[YY]*fY;
}
