#ifndef VIEW_H
#define VIEW_H

#include <windows.h>
#include "calc.h"

typedef struct {
		matrix	Orient;
		float	Scale;
		short Flags;
		RECT	Extent;	// absolute coordinates of project
		int		eX,eY;	// right-left and bottom-top
		RECT	Screen;	// the visible portion
		int		sX,sY;
		int		sM;		// smaller of sX or sY
		int		oX,oY;	// offset of visible within project
		float	CoarseSize,FineSize;
		float	RSize,USize;	// horizontal and vertical size, in xyz values
} view;

void initView(view*);
void loadIntoOpenGL(view*,int,int);
void mapScr2XYZ(view*,short,short,float*);
void mapScr2UV(view*,short,short,float*);

#define VF_NONPARALLEL	1	// view is not parallel to the screen
#define VF_LEFTHANDED	0	// left-handed universe
#define VF_RIGHTHANDED	2	// right-handed view
#define VF_HANDMASK		2	//

#endif

